> ## Documentation Index
> Fetch the complete documentation index at: https://razorpay-881012b3.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Register NACH and Charge First Payment Together

> Register a customer's mandate and charge them the first recurring payment as part of the same transaction via paper NACH.

<div style={{display:"flex",flexWrap:"wrap",alignItems:"center",gap:"0.35rem 0.9rem",border:"1px solid rgba(128,128,128,0.28)",borderRadius:"0.5rem",padding:"0.45rem 0.75rem",margin:"0 0 1.25rem",fontSize:"0.875rem"}}>
  <span style={{fontWeight:600}}>Available in</span>
  <span>🇮🇳 India</span>
</div>

The flow to complete an authorisation transaction using paper NACH differs from the other payment method's flow.

1. Create a customer.
2. Create an order by passing the `customer_id` and the method as `nach`. Razorpay generates a NACH form with the customer information pre-filled and ready to sign.
3. The customer can get the form in one of the following ways to sign it:
   * You can download the form from the Dashboard and send it to the customer.
   * A customer can download the form from the Hosted page (in the case of registration links).
4. The signed form can be uploaded in one of the following ways:
   * Using the Standard Checkout page.
   * Hosted page (in the case of registration links).
   * The customer can send you the form and you can upload the form for the customer. The acceptable image formats and size are:
     * jpeg
     * jpg
     * png
     * Maximum accepted size is 6 MB.

Once the details are validated, the authorisation transaction is completed and a token is generated. You can charge your customer as per your business model after the token status changes to `confirmed`.

## 1. Create an Authorisation Transaction

You can create an authorisation transaction using the [Razorpay APIs](#1-1-using-razorpay-apis) or [Registration Link](#1-2-using-a-registration-link).

### 1.1. Using Razorpay APIs

To create an authorisation transaction using the Razorpay APIs, you need to:

1. [Create a Customer](#1-1-1-create-a-customer).
2. [Create an Order](#1-1-2-create-an-order).
3. [Create Authorisation Payment using Razorpay APIs](#1-1-3-create-an-authorisation-payment).

#### 1.1.1. Create a Customer

Razorpay links recurring tokens to customers using a unique identifier generated through the Customer API.

You can create [customers](/docs/api/customers) with basic information such as `email` and `contact` and use them for various Razorpay offerings. The following endpoint creates a customer.

`POST /customers`

<AccordionGroup>
  <Accordion title="Sample Code">
    <CodeGroup>
      ```bash Curl theme={null}
      curl -u [YOUR_KEY_ID]:[YOUR_KEY_SECRET] \
      -X POST https://api.razorpay.com/v1/customers \
      -H "Content-Type: application/json" \
      -d '{
        "name": "<name>",
        "email": "<email>",
        "contact": "<phone>",
        "fail_existing": "0",
        "notes":{
          "note_key_1": "September",
          "note_key_2": "Make it so."
        }
      }'
      ```

      ```java Java theme={null}
      RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

      JSONObject customerRequest = new JSONObject();
      customerRequest.put("name","<name>");
      customerRequest.put("contact","<phone>");
      customerRequest.put("email","<email>");
      customerRequest.put("fail_existing", "0");
      JSONObject notes = new JSONObject();
      notes.put("notes_key_1","Tea, Earl Grey, Hot");
      notes.put("notes_key_2","Tea, Earl Grey… decaf.");
      customerRequest.put("notes",notes);

      Customer customer = razorpay.customers.create(customerRequest);
      ```

      ```python Python theme={null}
      import razorpay
      client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

      client.customer.create({
          'name': '<name>',
          'email': '<email>',
          'contact': '<phone>',
          'fail_existing': "0",
          'notes': {'note_key_1': 'September', 'note_key_2': 'Make it so.'}
          })
      ```

      ```go Go theme={null}
      import ( razorpay "github.com/razorpay/razorpay-go" )
      client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

      data := map[string]interface{}{
          "name": "<name>",
          "contact": <phone>,
          "email": "<email>",
          "fail_existing": "0",
          "notes": map[string]interface{}{
              "notes_key_1": "Tea, Earl Grey, Hot",
              "notes_key_2": "Tea, Earl Grey… decaf.",
          },
      }
      body, err := client.Customer.Create(data, nil)
      ```

      ```php PHP theme={null}
      $api = new Api($key_id, $secret);

      $api->customer->create(array('name' => '<name>', 'email' => '<email>','contact'=>'<phone>','fail_existing' => "0", 'notes'=> array('notes_key_1'=> 'Tea, Earl Grey, Hot','notes_key_2'=> 'Tea, Earl Grey… decaf'));
      ```

      ```csharp .NET theme={null}
      RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

      Dictionary<string, object> options = new Dictionary<string,object>();

      options.Add("name", "<name>"); 
      options.Add("contact", "<phone>"); 
      options.Add("email", "<email>"); 
      options.Add("fail_existing", "0"); 

      Customer customer = Customer.Create(options);
      ```

      ```ruby Ruby theme={null}
      require "razorpay"
      Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

      para_attr = {
        "name": "<name>",
        "contact": "<phone>",
        "email": "<email>",
        "fail_existing": "0",
        "notes": {
          "notes_key_1": "Tea, Earl Grey, Hot",
          "notes_key_2": "Tea, Earl Grey… decaf."
        }
      }

      Razorpay::Customer.create(para_attr)
      ```

      ```javascript Node.js theme={null}
      var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

      instance.customers.create({
        name: "<name>",
        contact: "<phone>",
        email: "<email>",
        fail_existing: "0",
        notes: {
          notes_key_1: "Tea, Earl Grey, Hot",
          notes_key_2: "Tea, Earl Grey… decaf."
        }
      })
      ```

      ```json Response theme={null}
      {
        "id":"cust_1Aa00000000001",
        "entity":"customer",
        "name":"<name>",
        "email":"<email>",
        "contact":"<phone>",
        "gstin":null,
        "notes":{
            "note_key_1":"September",
            "note_key_2":"Make it so."
        },
        "created_at ":1234567890
      }
      ```
    </CodeGroup>
  </Accordion>
</AccordionGroup>

##### Request Parameters

`name`
: `string` The name of the customer. For example, `Gaurav Kumar`.

`email`
: `string` The email address of the customer. For example, `gaurav.kumar@example.com`.

`contact`
: `string` The phone number of the customer. For example, `9876543210`.

`fail_existing` *optional*
: `string` The request throws an exception by default if a customer with the exact details already exists. You can pass an additional parameter `fail_existing` to get the existing customer's details in the response. Possible values:

* `1` (default): If a customer with the same details already exists, throws an error.
* `0`: If a customer with the same details already exists, fetches details of the existing customer.

`notes` *optional*
: `object` Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

#### 1.1.2. Create an Order

Use the [Orders API](/docs/api/orders) to create a unique Razorpay `order_id` that is associated with the authorisation transaction. The following endpoint creates an order.

`POST /orders`

<CodeGroup>
  ```bash Request theme={null}
  curl -u <YOUR_KEY_ID>:<YOUR_KEY_SECRET> \
  -X POST https://api.razorpay.com/v1/orders \
  -H "Content-Type: application/json" \
  -d '{
    "amount":0,
    "currency":"INR",
    "method":"nach",
    "customer_id": "cust_1Aa00000000001",
    "receipt": "Receipt No. 1",
    "notes": {
      "notes_key_1": "Beam me up Scotty",
      "notes_key_2": "Engage"
    },
    "token":{
      "first_payment_amount": 10000,
      "auth_type":"physical",
      "max_amount":10000000,
      "expire_at":1580480689,
      "notes": {
        "notes_key_1": "Tea, Earl Grey, Hot",
        "notes_key_2": "Tea, Earl Grey… decaf."
      },
      "bank_account":{
        "account_number":"11214311215411",
        "ifsc_code":"HDFC0000001",
        "beneficiary_name":"Gaurav Kumar",
        "account_type":"savings"
      },
      "nach":{
        "form_reference1":"Recurring Payment for Gaurav Kumar",
        "form_reference2":"Method Paper NACH",
        "description":"Paper NACH Gaurav Kumar"
      }
    }
  }'
  ```

  ```json Response theme={null}
  {
    "id":"order_1Aa00000000001",
    "entity":"order",
    "amount":0,
    "amount_paid":0,
    "amount_due":0,
    "currency":"INR",
    "receipt":"rcptid #10",
    "offer_id":null,
    "offers":{
      "entity":"collection",
      "count":0,
      "items":[]
    },
    "status":"created",
    "attempts":0,
    "notes": {
      "notes_key_1": "Beam me up Scotty",
      "notes_key_2": "Engage"
    },
    "created_at":1579775420,
    "token":{
      "method":"nach",
      "notes": {
        "notes_key_1": "Tea, Earl Grey, Hot",
        "notes_key_2": "Tea, Earl Grey… decaf."
      },
      "recurring_status":null,
      "failure_reason":null,
      "currency":"INR",
      "max_amount":10000000,
      "auth_type":"physical",
      "expire_at":1580480689,
      "nach":{
        "create_form":true,
        "form_reference1":"Recurring Payment for Gaurav Kumar",
        "form_reference2":"Method Paper NACH",
        "prefilled_form":"https://rzp.io/i/bitw",
        "upload_form_url":"https://rzp.io/i/gts",
        "description":"Paper NACH Gaurav Kumar"
      },
      "bank_account":{
        "ifsc":"HDFC0000001",
        "bank_name":"HDFC Bank",
        "name":"Gaurav Kumar",
        "account_number":"11214311215411",
        "account_type":"savings",
        "beneficiary_email":"gaurav.kumar@example.com",
        "beneficiary_mobile":"9876543210"
      },
      "first_payment_amount":10000
    }
  }
  ```
</CodeGroup>

Use the [Orders API](/docs/api/orders) to create a unique Razorpay `order_id` that is associated with the authorisation transaction. The following endpoint creates an order.

`POST /orders`

##### Request Parameters

`amount` *mandatory*
: `integer` Amount in currency subunits. For Paper NACH, the amount has to be `0`.

`currency` *mandatory*
: `string` The 3-letter ISO currency code for the payment. Currently, we only support `INR`.

`method` *mandatory*
: `string` The authorisation method. In this case the value will be `nach`.

`customer_id` *mandatory*
: `string` The unique identifier of the customer, who is to be charged. For example, `cust_D0cs04OIpPPU1F`.

`receipt` *optional*
: `string` A user-entered unique identifier for the order. For example, `rcptid #1`. This parameter should be mapped to the `order_id` sent by Razorpay.

`notes`*optional*
: `object` Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

`token`
: Details related to the authorisation transaction such as max amount and bank account information. Pass a value in the `first_payment_amount` parameter if you want to auto-charge the customer the first payment immediately after authorization.

`first_payment_amount` *optional*
: `integer` The amount, in paise, that should be auto-charged in addition to the authorization amount. For example, `100000`.

`auth_type` *mandatory*
: `string` In this case, it will be `physical`.

`bank_account`
: Customer's bank account details that will be printed on the NACH form.

`account_number`*mandatory*
: `string` Customer's bank account number. For example `11214311215411`.

`ifsc_code`*mandatory*
: `string` Customer's bank IFSC. For example `UTIB0000001`.

`beneficiary_name`*mandatory*
: `string` Customer's name. For example, `Gaurav Kumar`.

`account_type` *optional*
: `string` Customer's bank account type. Possible values:

* `savings` (default)
* `current`
* `cc` (Cash Credit)
* `nre` (SB-NRE)
* `nro` (SB-NRO)

`max_amount` *optional*
: `integer` Use to set the maximum amount per debit request. Know about [maximum and default values](/docs/payments/recurring-payments/paper-nach/faqs#3-is-there-a-limit-on-the-debit).

`expire_at` *optional*
: `integer` Timestamp, in Unix, that specifies when the registration link should expire. The value can range from the current date to 01-19-2038 (`2147483647`).

`nach`
: Additional information to be printed on the NACH form that your customer will sign.

`form_reference1` *optional*
: `string` A user-entered reference that appears on the NACH form.

`form_reference2` *optional*
: `string` A user-entered reference that appears on the NACH form.

`description` *optional*
: `string` A user-entered description that appears on the hosted page. For example, `Form for Gaurav Kumar.`

`notes`*optional*
: `object` Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

#### 1.1.3. Create an Authorisation Payment

After you create an order, you have to create an authorisation payment. To create an authorisation payment:

1. Download the Paper NACH form and send it to the customers.
2. Ask the customers to fill the form and send it to you.
3. You upload the received form via the create NACH File API. The acceptable image formats and size are jpeg, jpg and png. Maximum accepted size is 6 MB.

Use the below endpoint to upload the signed Paper NACH form via APIs.

`POST /payments/create/nach/file`

Razorpay's OCR-enabled NACH engine submits the form to NPCI on successful verification and you will receive a success/failure response.

Use the following API to upload the NACH file sent by the customer.

<CodeGroup>
  ```bash Request theme={null}
  curl -u <YOUR_KEY_ID>:<YOUR_KEY_SECRET> \
  -X POST 'https://api.razorpay.com/v1/payments/create/nach/file' \
  -H "Content-Type: multipart/form-data" \
  -F 'order_id=order_FoLdZrq6QGKUWg' \
  -F 'recurring=1' \
  -F 'file=@/Users/your_name/sample_uploaded.jpeg' // file path
  ```
</CodeGroup>

<CodeGroup>
  ```json Successful Response theme={null}
  {
    "razorpay_payment_id": "pay_FjDn43bvssCqEM",
    "razorpay_order_id": "order_FjDdQ6a0GluJ2c",
    "razorpay_signature": "f13775ea8a91e9bf229b9fdba3ad783f7ff2bdbce1c35e87a69ae7418808da04"
  }
  ```

  ```json Failure Response theme={null}
  {
     "error":{
        "code":"BAD_REQUEST_ERROR",
        "description":"file size exceeds limit",
        "field":null,
        "source":"customer",
        "step":"form_upload",
        "reason":"file size exceeds limit",
        "metadata":{
           "payment_id":null,
           "order_id":"order_DBJKIP31Y4jl8"
        }
     }
  }
  ```
</CodeGroup>

### 1.2. Using a Registration Link

Registration Links are an alternate way of creating an authorisation transaction. If you create a registration link, you need not create a customer or an order.

When you create a registration link, an [invoice](/docs/payments/invoices) is automatically issued to the customer. The customer can use the invoice to make the Authorisation Payment.

Know how to [create Registration Links](/docs/payments/recurring-payments/create) using the Dashboard.

<Info>
  **Handy Tips**

  You can use webhooks to get notifications about successful payments against a registration link. Know more about [Webhooks](/docs/api/payments/recurring-payments/webhooks#check-authorization-link-status-using-webhooks).
</Info>

A registration link must always have an amount (in paise) that the customer will be charged when making the authorisation payment. In the case of Paper NACH, the order amount must be `0`.

#### 1.2.1. Create a Registration Link

Use the below endpoint to create a registration link for recurring payments.

`POST /subscription_registration/auth_links`

<Info>
  **Download and Upload the Pre-filled NACH Form**

  Once the registration link is created, the customer should complete these steps:

  1. Download the pre-filled form using the Download NACH Form option on the Razorpay hosted page.
  2. Sign the form.
  3. Upload the signed form using the Upload NACH Form option on the Razorpay hosted page.
</Info>

<CodeGroup>
  ```bash Request theme={null}
  curl -u <YOUR_KEY_ID>:<YOUR_KEY_SECRET>
  -X POST https://api.razorpay.com/v1/subscription_registration/auth_links
  -H "Content-Type: application/json" \
  -d '{
    "customer":{
      "name":"Gaurav Kumar",
      "email":"gaurav.kumar@example.com",
      "contact":"9123456780"
    },
    "amount":0,
    "currency":"INR",
    "type":"link",
    "description":"12 p.m. Meals",
    "subscription_registration":{
      "method":"nach",
      "auth_type":"physical",
      "bank_account":{
        "beneficiary_name":"Gaurav Kumar",
        "account_number":"11214311215411",
        "account_type":"savings",
        "ifsc_code":"HDFC0001233"
      },
      "nach":{
        "form_reference1":"Recurring Payment for Gaurav Kumar",
        "form_reference2":"Method Paper NACH"
      },
      "expire_at":1947483647,
      "max_amount":50000
    },
    "receipt":"Receipt No. 1",
    "sms_notify":true,
    "email_notify":true,
    "expire_by":1647483647,
    "notes":{
      "note_key 1":"Beam me up Scotty",
      "note_key 2":"Tea. Earl Gray. Hot."
    }
  }'
  ```

  ```json Response theme={null}
  {
      "id": "inv_FHrZiAubEzDdaq",
      "entity": "invoice",
      "receipt": "Receipt No. 27",
      "invoice_number": "Receipt No. 27",
      "customer_id": "cust_BMB3EwbqnqZ2EI",
      "customer_details": {
          "id": "cust_BMB3EwbqnqZ2EI",
          "name": "Gaurav Kumar",
          "email": "gaurav.kumar@example.com",
          "contact": "9123456780",
          "gstin": null,
          "billing_address": null,
          "shipping_address": null,
          "customer_name": "Gaurav Kumar",
          "customer_email": "gaurav.kumar@example.com",
          "customer_contact": "9123456780"
      },
      "order_id": "order_FHrZiBOkWHZPOp",
      "line_items": [],
      "payment_id": null,
      "status": "issued",
      "expire_by": 1647483647,
      "issued_at": 1595491154,
      "paid_at": null,
      "cancelled_at": null,
      "expired_at": null,
      "sms_status": "sent",
      "email_status": "sent",
      "date": 1595491154,
      "terms": null,
      "partial_payment": false,
      "gross_amount": 0,
      "tax_amount": 0,
      "taxable_amount": 0,
      "amount": 0,
      "amount_paid": 0,
      "amount_due": 0,
      "currency": "INR",
      "currency_symbol": "₹",
      "description": "12 p.m. Meals",
      "notes": {
          "note_key 1": "Beam me up Scotty",
          "note_key 2": "Tea. Earl Gray. Hot."
      },
      "comment": null,
      "short_url": "https://rzp.io/i/bzDYbNg",
      "view_less": true,
      "billing_start": null,
      "billing_end": null,
      "type": "link",
      "group_taxes_discounts": false,
      "created_at": 1595491154,
      "idempotency_key": null,
      "token": {
          "method": "nach",
          "notes": {
              "note_key 1": "Beam me up Scotty",
              "note_key 2": "Tea. Earl Gray. Hot."
          },
          "recurring_status": null,
          "failure_reason": null,
          "currency": "INR",
          "max_amount": 50000,
          "auth_type": "physical",
          "expire_at": 1947483647,
          "nach": {
              "create_form": true,
              "form_reference1": "Recurring Payment for Gaurav Kumar",
              "form_reference2": "Method Paper NACH",
              "prefilled_form": "https://rzp.io/i/exdIzYN",
              "upload_form_url": "https://rzp.io/i/bzDYbNg",
              "description": "12 p.m. Meals"
          },
          "bank_account": {
              "ifsc": "HDFC0001233",
              "bank_name": "HDFC Bank",
              "name": "Gaurav Kumar",
              "account_number": "11214311215411",
              "account_type": "savings",
              "beneficiary_email": "gaurav.kumar@example.com",
              "beneficiary_mobile": "9123456780"
          },
          "first_payment_amount": 0
      },
      "nach_form_url": "https://rzp.io/i/exdIzYN"
  }
  ```
</CodeGroup>

The following endpoint creates a registration link for recurring payments.

`POST /subscription_registration/auth_links`

<CodeGroup>
  ```bash Curl theme={null}
  curl -u <YOUR_KEY_ID>:<YOUR_KEY_SECRET>
  -X POST https://api.razorpay.com/v1/subscription_registration/auth_links
  -H "Content-Type: application/json" \
  -d '{
    "customer":{
      "name":"Gaurav Kumar",
      "email":"gaurav.kumar@example.com",
      "contact":"9123456780"
    },
    "amount":0,
    "currency":"INR",
    "type":"link",
    "description":"12 p.m. Meals",
    "subscription_registration":{
      "method":"nach",
      "auth_type":"physical",
      "bank_account":{
        "beneficiary_name":"Gaurav Kumar",
        "account_number":"11214311215411",
        "account_type":"savings",
        "ifsc_code":"HDFC0001233"
      },
      "nach":{
        "form_reference1":"Recurring Payment for Gaurav Kumar",
        "form_reference2":"Method Paper NACH"
      },
      "expire_at":1947483647,
      "max_amount":50000
    },
    "receipt":"Receipt No. 1",
    "sms_notify":true,
    "email_notify":true,
    "expire_by":1647483647,
    "notes":{
      "note_key 1":"Beam me up Scotty",
      "note_key 2":"Tea. Earl Gray. Hot."
    }
  }'
  ```

  ```java Java theme={null}
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  JSONObject registrationLinkRequest = new JSONObject();
  JSONObject customer = new JSONObject();
  customer.put("name","Gaurav Kumar");
  customer.put("email","gaurav.kumar@example.com");
  customer.put("contact","9123456780");
  registrationLinkRequest.put("customer", customer);
  registrationLinkRequest.put("type", "link");
  registrationLinkRequest.put("amount", 0);
  registrationLinkRequest.put("currency", "INR");
  registrationLinkRequest.put("description", "12 p.m. Meals");
  JSONObject subscriptionRegistration = new JSONObject();
  subscriptionRegistration.put("method","nach");
  subscriptionRegistration.put("auth_type","physical");
  subscriptionRegistration.put("max_amount",50000);
  subscriptionRegistration.put("expire_at",1609423824);
  JSONObject bankAccount = new JSONObject();
  bankAccount.put("beneficiary_name","Gaurav Kumar");
  bankAccount.put("account_number","11214311215411");
  bankAccount.put("account_type","savings");
  bankAccount.put("ifsc_code","HDFC0001233");
  JSONObject nach = new JSONObject();
  nach.put("form_reference1","Recurring Payment for Gaurav Kumar");
  nach.put("form_reference2","Method Paper NACH");
  subscriptionRegistration.put("bank_account",bankAccount);
  subscriptionRegistration.put("nach",nach);
  registrationLinkRequest.put("subscription_registration", subscriptionRegistration);
  registrationLinkRequest.put("receipt", "Receipt No. #27");
  registrationLinkRequest.put("email_notify", true);
  registrationLinkRequest.put("sms_notify", true);
  registrationLinkRequest.put("expire_by", 1580479824);
  JSONObject notes = new JSONObject();
  notes.put("notes_key_1","Tea, Earl Grey, Hot");
  notes.put("notes_key_2","Tea, Earl Grey… decaf.");
  registrationLinkRequest.put("notes", notes);

  Invoice invoice = razorpay.invoices.createRegistrationLink(registrationLinkRequest);
  ```

  ```php PHP theme={null}
  $api = new Api($key_id, $secret);

  $api->subscription->createSubscriptionRegistration(array('customer'=>array('name'=>'Gaurav Kumar','email'=>'gaurav.kumar@example.com','contact'=>'9123456780'),'amount'=>100, 'type'=>'link','currency'=>'INR','description'=>'Registration Link for Gaurav Kumar','subscription_registration'=>array('first_payment_amount'=>100, 'method'=>'nach', 'auth_type'=>'physical' ,'max_amount'=>'50000','expire_at'=>'1634215992','bank_account'=>array('beneficiary_name'=>'Gaurav Kumar', 'account_number'=>'11214311215411', 'account_type'=>'savings', 'ifsc_code'=>'HDFC0001233'), 'nach'=> array('form_reference1'=> 'Recurring Payment for Gaurav Kumar','form_reference2'=> 'Method Paper NACH')),'receipt'=>'Receipt No. 5','email_notify'=>true,'sms_notify'=>true,'expire_by'=>1634215992, 'notes'=> array('note_key 1'=> 'Beam me up Scotty','note_key 2'=> 'Tea. Earl Gray. Hot.'));
  ```

  ```javascript Node.js theme={null}
  var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

  instance.payments.createRecurringPayment({
    customer: {
      name: "Gaurav Kumar",
      email: "gaurav.kumar@example.com",
      contact: 9123456780
    },
    amount: 100,
    type: "link",
    currency: "INR",
    description: "Registration Link for Gaurav Kumar",
    subscription_registration: {
      first_payment_amount: 100,
      method: "nach",
      auth_type: "physical",
      max_amount: 50000,
      expire_at: 1634215992,
      bank_account: {
        beneficiary_name: "Gaurav Kumar",
        account_number: "11214311215411",
        account_type: "savings",
        ifsc_code: "HDFC0001233"
      },
      nach: {
        form_reference1: "Recurring Payment for Gaurav Kumar",
        form_reference2: "Method Paper NACH"
      }
    },
    receipt: "Receipt No. 5",
    email_notify: true,
    sms_notify: true,
    expire_by: 1634215992,
    notes: {
      "note_key 1": "Beam me up Scotty",
      "note_key 2": "Tea. Earl Gray. Hot."
    }
  })
  ```

  ```python Python theme={null}
  client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

  client.payment.createRecurring({
     "customer":{
        "name":"Gaurav Kumar",
        "email":"gaurav.kumar@example.com",
        "contact":9123456780
     },
     "amount":100,
     "type":"link",
     "currency":"INR",
     "description":"Registration Link for Gaurav Kumar",
     "subscription_registration":{
        "first_payment_amount":100,
        "method":"nach",
        "auth_type":"physical",
        "max_amount":50000,
        "expire_at":1634215992,
        "bank_account":{
           "beneficiary_name":"Gaurav Kumar",
           "account_number":11214311215411,
           "account_type":"savings",
           "ifsc_code":"HDFC0001233"
        },
        "nach":{
           "form_reference1":"Recurring Payment for Gaurav Kumar",
           "form_reference2":"Method Paper NACH"
        }
     },
     "receipt":"Receipt No. 5",
     "email_notify": True,
     "sms_notify":True,
     "expire_by":1634215992,
     "notes":{
        "note_key 1":"Beam me up Scotty",
        "note_key 2":"Tea. Earl Gray. Hot."
     }
  })
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  para_attr = {
    "customer": {
      "name": "Gaurav Kumar",
      "email": "gaurav.kumar@example.com",
      "contact": 9123456780
    },
    "amount": 100,
    "type": "link",
    "currency": "INR",
    "description": "Registration Link for Gaurav Kumar",
    "subscription_registration": {
      "first_payment_amount": 100,
      "method": "nach",
      "auth_type": "physical",
      "max_amount": 50000,
      "expire_at": 1634215992,
      "bank_account": {
        "beneficiary_name": "Gaurav Kumar",
        "account_number": 11214311215411,
        "account_type": "savings",
        "ifsc_code": "HDFC0001233"
      },
      "nach": {
        "form_reference1": "Recurring Payment for Gaurav Kumar",
        "form_reference2": "Method Paper NACH"
      }
    },
    "receipt": "Receipt No. 27",
    "email_notify": 1,
    "sms_notify": 1,
    "expire_by": 1634215992,
    "notes": {
      "note_key 1": "Beam me up Scotty",
      "note_key 2": "Tea. Earl Gray. Hot."
    }
  }
  Razorpay::SubscriptionRegistration.create(para_attr)
  ```

  ```go Go theme={null}
  import ( razorpay "github.com/razorpay/razorpay-go" )
  client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

  data:= map[string]interface{}{
    "customer":map[string]interface{}{
      "name":"Gaurav Kumar",
      "email":"gaurav.kumar@example.com",
      "contact":"9123456780",
    },
    "amount":0,
    "currency":"INR",
    "type":"link",
    "description":"12 p.m. Meals",
    "subscription_registration":map[string]interface{}{
      "method":"nach",
      "auth_type":"physical",
      "bank_account":map[string]interface{}{
        "beneficiary_name":"Gaurav Kumar",
        "account_number":"11214311215411",
        "account_type":"savings",
        "ifsc_code":"HDFC0001233",
      },
      "nach":map[string]interface{}{
        "form_reference1":"Recurring Payment for Gaurav Kumar",
        "form_reference2":"Method Paper NACH",
      },
      "expire_at":1947483647,
      "max_amount":50000,
    },
    "receipt":"Receipt No. 1",
    "sms_notify":true,
    "email_notify":true,
    "expire_by":1647483647,
    "notes":map[string]interface{}{
      "note_key 1":"Beam me up Scotty",
      "note_key 2":"Tea. Earl Gray. Hot.",
    },
  }

  body, err := client.Invoice.CreateRegistrationLink(data, nil)
  ```

  ```csharp .NET theme={null}
  RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  Dictionary<string, object> registrationLinkRequest = new Dictionary<string, object>();
  Dictionary<string, object> customer = new Dictionary<string, object>();
  customer.Add("name","Gaurav Kumar");
  customer.Add("email","gaurav.kumar@example.com");
  customer.Add("contact","9123456780");
  registrationLinkRequest.Add("customer", customer);
  registrationLinkRequest.Add("type", "link");
  registrationLinkRequest.Add("amount", 0);
  registrationLinkRequest.Add("currency", "INR");
  registrationLinkRequest.Add("description", "12 p.m. Meals");
  Dictionary<string, object> subscriptionRegistration = new Dictionary<string, object>();
  subscriptionRegistration.Add("method","nach");
  subscriptionRegistration.Add("auth_type","physical");
  subscriptionRegistration.Add("max_amount",50000);
  subscriptionRegistration.Add("expire_at",1609423824);
  Dictionary<string, object> bankAccount = new Dictionary<string, object>();
  bankAccount.Add("beneficiary_name","Gaurav Kumar");
  bankAccount.Add("account_number","11214311215411");
  bankAccount.Add("account_type","savings");
  bankAccount.Add("ifsc_code","HDFC0001233");
  Dictionary<string, object> nach = new Dictionary<string, object>();
  nach.Add("form_reference1","Recurring Payment for Gaurav Kumar");
  nach.Add("form_reference2","Method Paper NACH");
  subscriptionRegistration.Add("bank_account",bankAccount);
  subscriptionRegistration.Add("nach",nach);
  registrationLinkRequest.Add("subscription_registration", subscriptionRegistration);
  registrationLinkRequest.Add("receipt", "Receipt No. #111");
  registrationLinkRequest.Add("email_notify", true);
  registrationLinkRequest.Add("sms_notify", true);
  registrationLinkRequest.Add("expire_by", 1580479824);
  Dictionary<string, object> notes = new Dictionary<string, object>();
  notes.Add("notes_key_1","Tea, Earl Grey, Hot");
  notes.Add("notes_key_2","Tea, Earl Grey… decaf.");
  registrationLinkRequest.Add("notes", notes);

  Invoice invoice = client.Invoice.CreateRegistrationLink(registrationLinkRequest);
  ```

  ```json Response theme={null}
  {
      "id": "inv_FHrZiAubEzDdaq",
      "entity": "invoice",
      "receipt": "Receipt No. 27",
      "invoice_number": "Receipt No. 27",
      "customer_id": "cust_BMB3EwbqnqZ2EI",
      "customer_details": {
          "id": "cust_BMB3EwbqnqZ2EI",
          "name": "Gaurav Kumar",
          "email": "gaurav.kumar@example.com",
          "contact": "9123456780",
          "gstin": null,
          "billing_address": null,
          "shipping_address": null,
          "customer_name": "Gaurav Kumar",
          "customer_email": "gaurav.kumar@example.com",
          "customer_contact": "9123456780"
      },
      "order_id": "order_FHrZiBOkWHZPOp",
      "line_items": [],
      "payment_id": null,
      "status": "issued",
      "expire_by": 1647483647,
      "issued_at": 1595491154,
      "paid_at": null,
      "cancelled_at": null,
      "expired_at": null,
      "sms_status": "sent",
      "email_status": "sent",
      "date": 1595491154,
      "terms": null,
      "partial_payment": false,
      "gross_amount": 0,
      "tax_amount": 0,
      "taxable_amount": 0,
      "amount": 0,
      "amount_paid": 0,
      "amount_due": 0,
      "currency": "INR",
      "currency_symbol": "₹",
      "description": "12 p.m. Meals",
      "notes": {
          "note_key 1": "Beam me up Scotty",
          "note_key 2": "Tea. Earl Gray. Hot."
      },
      "comment": null,
      "short_url": "https://rzp.io/i/bzDYbNg",
      "view_less": true,
      "billing_start": null,
      "billing_end": null,
      "type": "link",
      "group_taxes_discounts": false,
      "created_at": 1595491154,
      "idempotency_key": null,
      "token": {
          "method": "nach",
          "notes": {
              "note_key 1": "Beam me up Scotty",
              "note_key 2": "Tea. Earl Gray. Hot."
          },
          "recurring_status": null,
          "failure_reason": null,
          "currency": "INR",
          "max_amount": 50000,
          "auth_type": "physical",
          "expire_at": 1947483647,
          "nach": {
              "create_form": true,
              "form_reference1": "Recurring Payment for Gaurav Kumar",
              "form_reference2": "Method Paper NACH",
              "prefilled_form": "https://rzp.io/i/exdIzYN",
              "upload_form_url": "https://rzp.io/i/bzDYbNg",
              "description": "12 p.m. Meals"
          },
          "bank_account": {
              "ifsc": "HDFC0001233",
              "bank_name": "HDFC Bank",
              "name": "Gaurav Kumar",
              "account_number": "11214311215411",
              "account_type": "savings",
              "beneficiary_email": "gaurav.kumar@example.com",
              "beneficiary_mobile": "9123456780"
          },
          "first_payment_amount": 0
      },
      "nach_form_url": "https://rzp.io/i/exdIzYN"
  }
  ```
</CodeGroup>

<Info>
  **Download and Upload the Pre-filled NACH Form**

  Once the registration link is created, the customer should complete these steps:

  1. Download the pre-filled form using the Download NACH Form option on the Razorpay hosted page.
  2. Sign the form.
  3. Upload the signed form using the Upload NACH Form option on the Razorpay hosted page.
</Info>

<CodeGroup>
  ```bash Request theme={null}
  curl -u <YOUR_KEY_ID>:<YOUR_KEY_SECRET>
  -X POST https://api.razorpay.com/v1/subscription_registration/auth_links
  -H "Content-Type: application/json" \
  -d '{
    "customer":{
      "name":"Gaurav Kumar",
      "email":"gaurav.kumar@example.com",
      "contact":"9123456780"
    },
    "amount":0,
    "currency":"INR",
    "type":"link",
    "description":"12 p.m. Meals",
    "subscription_registration":{
      "first_payment_amount": 10000,
      "method":"nach",
      "auth_type":"physical",
      "bank_account":{
        "beneficiary_name":"Gaurav Kumar",
        "account_number":"11214311215411",
        "account_type":"savings",
        "ifsc_code":"HDFC0001233"
      },
      "nach":{
        "form_reference1":"Recurring Payment for Gaurav Kumar",
        "form_reference2":"Method Paper NACH"
      },
      "expire_at":1947483647,
      "max_amount":50000
    },
    "receipt":"Receipt No. 27",
    "sms_notify":true,
    "email_notify":true,
    "expire_by":1647483647,
    "notes":{
      "note_key 1":"Beam me up Scotty",
      "note_key 2":"Tea. Earl Gray. Hot."
    }
  }'
  ```

  ```json Response theme={null}
  {
      "id": "inv_FHrZiAubEzDdaq",
      "entity": "invoice",
      "receipt": "Receipt No. 27",
      "invoice_number": "Receipt No. 27",
      "customer_id": "cust_BMB3EwbqnqZ2EI",
      "customer_details": {
          "id": "cust_BMB3EwbqnqZ2EI",
          "name": "Gaurav Kumar",
          "email": "gaurav.kumar@example.com",
          "contact": "9123456780",
          "gstin": null,
          "billing_address": null,
          "shipping_address": null,
          "customer_name": "Gaurav Kumar",
          "customer_email": "gaurav.kumar@example.com",
          "customer_contact": "9123456780"
      },
      "order_id": "order_FHrZiBOkWHZPOp",
      "line_items": [],
      "payment_id": null,
      "status": "issued",
      "expire_by": 1647483647,
      "issued_at": 1595491154,
      "paid_at": null,
      "cancelled_at": null,
      "expired_at": null,
      "sms_status": "sent",
      "email_status": "sent",
      "date": 1595491154,
      "terms": null,
      "partial_payment": false,
      "gross_amount": 0,
      "tax_amount": 0,
      "taxable_amount": 0,
      "amount": 0,
      "amount_paid": 0,
      "amount_due": 0,
      "currency": "INR",
      "currency_symbol": "₹",
      "description": "12 p.m. Meals",
      "notes": {
          "note_key 1": "Beam me up Scotty",
          "note_key 2": "Tea. Earl Gray. Hot."
      },
      "comment": null,
      "short_url": "https://rzp.io/i/bzDYbNg",
      "view_less": true,
      "billing_start": null,
      "billing_end": null,
      "type": "link",
      "group_taxes_discounts": false,
      "created_at": 1595491154,
      "idempotency_key": null,
      "token": {
          "method": "nach",
          "notes": {
              "note_key 1": "Beam me up Scotty",
              "note_key 2": "Tea. Earl Gray. Hot."
          },
          "recurring_status": null,
          "failure_reason": null,
          "currency": "INR",
          "max_amount": 50000,
          "auth_type": "physical",
          "expire_at": 1947483647,
          "nach": {
              "create_form": true,
              "form_reference1": "Recurring Payment for Gaurav Kumar",
              "form_reference2": "Method Paper NACH",
              "prefilled_form": "https://rzp.io/i/exdIzYN",
              "upload_form_url": "https://rzp.io/i/bzDYbNg",
              "description": "12 p.m. Meals"
          },
          "bank_account": {
              "ifsc": "HDFC0001233",
              "bank_name": "HDFC Bank",
              "name": "Gaurav Kumar",
              "account_number": "11214311215411",
              "account_type": "savings",
              "beneficiary_email": "gaurav.kumar@example.com",
              "beneficiary_mobile": "9123456780"
          },
          "first_payment_amount": 0
      },
      "nach_form_url": "https://rzp.io/i/exdIzYN"
  }
  ```
</CodeGroup>

##### Request Parameters

`customer`
: `object` Details of the customer to whom the registration link is sent.

`name` *mandatory*
: `string` Customer's name.

`email` *mandatory*
: `string` Customer's email address.

`contact`*mandatory*
: `integer` Customer's contact number.

`type` *mandatory*
: `string` In this case, the value is `link`.

`amount` *mandatory*
: `integer` The payment amount in the smallest currency sub-unit.

`currency` *mandatory*
: `string` The 3-letter ISO currency code for the payment.

`description` *mandatory*
: `string` A description that appears on the hosted page.

`subscription_registration`
: Details of the authorisation payment.

`first_payment_amount` *optional*
: `integer` The amount, in paise, the customer should be auto-charged in addition to the authorization amount. For example, `100000`.

`subscription_registration`
: Details of the authorisation payment.

`method` *mandatory*
: `string` The Paper NACH method used to make the authorisation transaction. Here, it is `physical`.

`auth_type` *mandatory*
: `string` The payment method used to make the authorisation transaction. Here, it is `nach`.

`bank_account`
: The customer's bank account details.

`beneficiary_name` *mandatory*
: `string` The beneficiary name. For example, `Gaurav Kumar`.

`account_number` *mandatory*
: `integer` The customer's bank account number. For example, `11214311215411`.

`account_type` *mandatory*
: `string` The customer's bank account type. Possible values:

* `savings`
* `current`

`ifsc_code` *mandatory*
: `string` The customer's bank IFSC. For example, `HDFC0000001`.

`max_amount` *optional*
: `integer` Use to set the maximum amount, in paise, per debit request. Know about [maximum and default values](/docs/payments/recurring-payments/paper-nach/faqs#3-is-there-a-limit-on-the-debit).

`expire_at` *optional*
: `integer` The Unix timestamp till when you can use the token (authorisation on the payment method) to charge the customer subsequent payments. The default value is 10 years. The value can range from the current date to 31-12-2099 (`4101580799`).

`nach`
: Additional information to be printed on the NACH form your customer will sign.

`form_reference1` *optional*
: `string` A user entered reference that appears on the NACH form.

`form_reference2` *optional*
: `string` A user entered reference that appears on the NACH form.

`description` *optional*
: `string` A user entered description that appears on the hosted page. For example, `Form for Gaurav Kumar.`

`sms_notify` *optional*
: `boolean` Indicates if SMS notifications are to be sent by Razorpay. Possible values:

* `true` (default): Notifications are sent by Razorpay .
* `false`: Notifications are not sent by Razorpay.

`email_notify` *optional*
: `boolean` Indicates if email notifications are to be sent by Razorpay. Possible values:

* `true` (default): Notifications are sent by Razorpay .
* `false`: Notifications are not sent by Razorpay.

`expire_by` *optional*
: `integer` The Unix timestamp indicates the expiry of the registration link.

`receipt` *optional*
: `string` A unique identifier entered by you for the order. For example, `Receipt No. 1`. You should map this parameter to the `order_id` sent by Razorpay.

`notes` *optional*
: `object` This is a key-value pair that is used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

#### 1.2.2. Send/Resend Notifications

The following endpoint sends/resends notifications with the short URL to the customer:

`POST /invoices/:id/notify_by/:medium`

<AccordionGroup>
  <Accordion title="Sample Code">
    <CodeGroup>
      ```bash Curl theme={null}
       curl -u [YOUR_KEY_ID]:[YOUR_KEY_SECRET]
       -X POST https://api.razorpay.com/v1/invoices/inv_1Aa00000000001/notify_by/sms
      ```

      ```java Java theme={null}
       RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

       String invoiceId = "inv_1Aa00000000001";

       String medium = "sms";

       Invoice invoice = razorpay.invoices.notifyBy(invoiceId, medium);
      ```

      ```php PHP theme={null}
       $api = new Api($key_id, $secret);

       $api->invoice->fetch($invoiceId)->notify($medium);
      ```

      ```javascript Node.js theme={null}
       var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

       instance.invoices.notifyBy(invoiceId, medium)
      ```

      ```python Python theme={null}
       client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

       client.invoice.notify_by(invoiceId, medium)
      ```

      ```ruby Ruby theme={null}
       require "razorpay"
       Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

       invoiceId = "inv_JDdNb4xdf4gxQ7"

       medium = "email" 

       Razorpay::Invoice.notify_by(invoiceId, medium)
      ```

      ```go Go theme={null}
       import ( razorpay "github.com/razorpay/razorpay-go" )
       client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

       body, err := client.Invoice.Notify("<invoiceId>", "<medium>", nil, nil)
      ```

      ```csharp .NET theme={null}
       RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

       string invoiceId = "inv_Z6t7VFTb9xHeOs";

       string medium = "sms";

       Invoice invoice = client.Invoice.Fetch(invoiceId).NotifyBy(medium);
      ```
    </CodeGroup>

    ```json Response theme={null}
    {
      "success": true
    }
    ```
  </Accordion>
</AccordionGroup>

##### Path Parameters

`id`*mandatory*
: `string` The unique identifier of the invoice linked to the registration link for which you want to send the notification. For example, `inv_1Aa00000000001`.

`medium` *mandatory*
: `string` Determines through which medium you want to resend the notification. Possible values:

* `sms`
* `email`

#### 1.2.3. Cancel a Registration Link

The following endpoint cancels a registration link.

`POST /invoices/:id/cancel`

<CodeGroup>
  ```bash Curl theme={null}
  curl -u <YOUR_KEY_ID>:<YOUR_KEY_SECRET>
  -X POST https://api.razorpay.com/v1/invoices/inv_1Aa00000000001/cancel
  ```

  ```java Java theme={null}
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  String invoiceId = "inv_1Aa00000000001";

  Invoice invoice = razorpay.invoices.cancel(invoiceId);
  ```

  ```php PHP theme={null}
  $api = new Api($key_id, $secret);

  $api->invoice->fetch($invoiceId)->cancel();
  ```

  ```javascript Node.js theme={null}
  var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

  instance.invoices.cancel(invoiceId);
  ```

  ```python Python theme={null}
  client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

  client.invoice.cancel(invoiceId)
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  invoiceId = "inv_JDdNb4xdf4gxQ7"

  Razorpay::Invoice.cancel(invoiceId)
  ```

  ```go Go theme={null}
  import ( razorpay "github.com/razorpay/razorpay-go" )
  client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

  body, err := client.Invoice.Cancel("<invoiceId>", nil, nil)
  ```

  ```csharp .NET theme={null}
  RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  string invoiceId = "inv_DAweOiQ7amIUVd";

  Invoice invoice = client.Invoice.Fetch(invoiceId).Cancel();
  ```

  ```json Response theme={null}
  {
    "amount": 0,
    "amount_due": 0,
    "amount_paid": 0,
    "auth_link_status": "cancelled",
    "billing_end": null,
    "billing_start": null,
    "cancelled_at": 1661428198,
    "comment": null,
    "created_at": 1661424249,
    "currency": "INR",
    "currency_symbol": "₹",
    "customer_details": {
      "billing_address": null,
      "contact": "9023456780",
      "customer_contact": "9023456780",
      "customer_email": "gaurav.kumar1@example.com",
      "customer_name": "Gaurav Kumar",
      "email": "gaurav.kumar1@example.com",
      "gstin": null,
      "id": "cust_K9pyoGi6vDUMgM",
      "name": "Gaurav Kumar",
      "shipping_address": null
    },
    "customer_id": "cust_K9pyoGi6vDUMgM",
    "date": 1661424248,
    "description": "salsa",
    "email_status": "sent",
    "entity": "invoice",
    "expire_by": 1947483647,
    "expired_at": null,
    "first_payment_min_amount": null,
    "gross_amount": 0,
    "group_taxes_discounts": false,
    "id": "inv_K9pyoiihbl98jD",
    "idempotency_key": null,
    "invoice_number": "trtrtr1",
    "issued_at": 1661424248,
    "line_items": [],
    "nach_form_url": "https://rzp.io/i/Ui2gOJOom",
    "notes": {
      "note_key 1": "Beam me up Scotty",
      "note_key 2": "Tea. Earl Gray. Hot."
    },
    "order_id": "order_K9pypNRrcL4bij",
    "paid_at": null,
    "partial_payment": false,
    "payment_id": null,
    "receipt": "trtrtr1",
    "reminder_status": null,
    "short_url": "https://rzp.io/i/WNa96WB",
    "sms_status": "sent",
    "status": "cancelled",
    "subscription_status": null,
    "supply_state_code": null,
    "tax_amount": 0,
    "taxable_amount": 0,
    "terms": null,
    "token": {
      "auth_type": "physical",
      "bank_account": {
        "account_number": "11214311215411",
        "account_type": "savings",
        "bank_name": "HDFC Bank",
        "beneficiary_email": "gaurav.kumar1@example.com",
        "beneficiary_mobile": "9023456780",
        "ifsc": "HDFC0001233",
        "name": "Gaurav Kumar"
      },
      "currency": "INR",
      "expire_at": 1947483647,
      "failure_reason": null,
      "first_payment_amount": 0,
      "max_amount": 50000,
      "method": "nach",
      "nach": {
        "create_form": true,
        "description": "salsa",
        "form_reference1": "Recurring Payment for Gaurav Kumar",
        "form_reference2": "Method Paper NACH",
        "prefilled_form": "https://rzp.io/i/WYAUISM64",
        "prefilled_form_transient": "https://rzp.io/i/Ui2gOJOom",
        "upload_form_url": "https://rzp.io/i/WNa96WB"
      },
      "notes": {
        "note_key 1": "Beam me up Scotty",
        "note_key 2": "Tea. Earl Gray. Hot."
      },
      "recurring_status": null
    },
    "type": "link",
    "user_id": null,
    "view_less": true
  }
  ```
</CodeGroup>

##### Path Parameter

`id` *mandatory*
: `string` The unique identifier for the invoice linked to the registration link that you want to cancel. For example, `inv_1Aa00000000001`.

## 2. Fetch and Manage Tokens

Once you capture a payment, Razorpay Checkout returns a `razorpay_payment_id`. You can use this id to fetch the `token_id`, which is used to create and charge subsequent payments.

You can retrieve the `token_id` using the [Dashboard](/docs/payments/recurring-payments/create#3-search-for-the-token) or the APIs given below.

### 2.1. Fetch Token by Payment ID

Use the below endpoint to fetch the `token_id` using a `payment_id`.

`GET /payments/:id`

<CodeGroup>
  ```bash Curl theme={null}
  curl -u [YOUR_KEY_ID]:[YOUR_KEY_SECRET] \
  -X GET https://api.razorpay.com/v1/payments/pay_1Aa00000000003
  ```

  ```java Java theme={null}
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_SECRET}"

  String paymentId = "pay_1Aa00000000003";

  Payment payment = razorpay.payments.fetch(paymentId);
  ```

  ```php PHP theme={null}
  $api = new Api($key_id, $secret);

  $api->payment->fetch($paymentId);
  ```

  ```javascript Node.js theme={null}
  var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

  instance.payments.fetch(paymentId)
  ```

  ```python Python theme={null}
  client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

  client.payment.fetch(paymentId)
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  paymentId = "pay_1Aa00000000003"

  Razorpay::Payment.fetch(paymentId)
  ```

  ```go Go theme={null}
  import ( razorpay "github.com/razorpay/razorpay-go" )
  client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

  body, err := client.Payment.Fetch("<paymentId>", nil, nil)
  ```

  ```csharp .NET theme={null}
  RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  string paymentId = "pay_Z6t7VFTb9xHeOs";

  Payment payment = client.Payment.Fetch(paymentId);
  ```

  ```json Response theme={null}
  {
    "id": "pay_EnLNTjINiPkMEZ",
    "entity": "payment",
    "amount": 0,
    "currency": "INR",
    "status": "captured",
    "order_id": "order_EnLLfglmKksr4K",
    "invoice_id": "inv_EnLLfgCzRfcMuh",
    "international": false,
    "method": "nach",
    "amount_refunded": 0,
    "refund_status": null,
    "captured": true,
    "description": "Invoice #inv_EnLLfgCzRfcMuh",
    "card_id": null,
    "bank": "UTIB",
    "wallet": null,
    "vpa": null,
    "email": "gaurav.kumar@example.com",
    "contact": "+919876543210",
    "customer_id": "cust_DtHaBuooGHTuyZ",
    "token_id": "token_EnLNTnn7uyRg5V",
    "notes": {
      "note_key 1": "Beam me up Scotty",
      "note_key 2": "Tea. Earl Gray. Hot."
    },
    "fee": 0,
    "tax": 0,
    "error_code": null,
    "error_description": null,
    "error_source": null,
    "error_step": null,
    "error_reason": null,
    "acquirer_data": {},
    "created_at": 1588827564
  }
  ```
</CodeGroup>

<Info>
  **Handy Tips**

  You can also retrieve the `token_id` via the [payment.authorized webhook](/docs/api/payments/recurring-payments/webhooks#payment-authorized).
</Info>

#### Path Parameter

`id` *mandatory*
: `string` The unique identifier of the payment to be retrieved. For example, `pay_1Aa00000000002`.

### 2.2. Fetch Tokens by Customer ID

Use the below endpoint to fetch tokens linked to a customer.

A customer can have multiple tokens tied to them. These tokens can be used to create subsequent payments for multiple products or services.

<Warning>
  **Watch Out!**

  This endpoint will not fetch the details of expired and unused tokens.
</Warning>

`GET /customers/:id/tokens`

<CodeGroup>
  ```bash Curl theme={null}
  curl -u [YOUR_KEY_ID]:[YOUR_KEY_SECRET] \
  -X GET https://api.razorpay.com/v1/customers/cust_1Aa00000000002/tokens
  ```

  ```java Java theme={null}
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  String customerId = "cust_1Aa00000000004";

  Customer customer = razorpay.customers.fetchTokens(customerId);
  ```

  ```php PHP theme={null}
  $api = new Api($key_id, $secret);

  $api->customer->fetch($customerId)->tokens()->all();
  ```

  ```javascript Node.js theme={null}
  var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

  instance.customers.fetchTokens(customerId)
  ```

  ```python Python theme={null}
  client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

  client.token.all(customerId)
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  customerId = "cust_1Aa00000000004"

  Razorpay::Customer.fetchTokens(customerId)
  ```

  ```go Go theme={null}
  import ( razorpay "github.com/razorpay/razorpay-go" )
  client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

  body, err := client.Token.All("<customerId>", nil, nil)
  ```

  ```csharp .NET theme={null}
  RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  string customerId = "cust_1Aa00000000001";

  List<Token> token = client.Customer.Fetch(customerId).Tokens();
  ```

  ```json Response theme={null}
  {
    "entity": "collection",
    "count": 1,
    "items": [
      {
        "id": "token_EhYgIE3pOyMQpD",
        "entity": "token",
        "token": "3mQ5Czc6APNppI",
        "bank": "HDFC",
        "wallet": null,
        "method": "nach",
        "vpa": null,
        "recurring": true,
        "recurring_details": {
          "status": "confirmed",
          "failure_reason": null
        },
        "auth_type": "physical",
        "mrn": null,
        "used_at": 1587564373,
        "created_at": 1587564373,
        "dcc_enabled": false
      }
    ]
  }
  ```
</CodeGroup>

#### Path Parameter

`id` *mandatory*
: `string` The unique identifier of the customer for whom tokens are to be retrieved. For example, `cust_1Aa00000000002`.

### 2.3. Delete Tokens

The following endpoint deletes a token.

`DELETE /customers/:customer_id/tokens/:token_id`

<CodeGroup>
  ```bash Curl theme={null}
  curl -u [YOUR_KEY_ID]:[YOUR_KEY_SECRET] \
  -X DELETE https://api.razorpay.com/v1/customers/cust_1Aa00000000002/tokens/token_1Aa00000000001
  ```

  ```java Java theme={null}
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  String customerId = "cust_1Aa00000000002";

  String tokenId = "token_1Aa00000000001";

  Customer customer = razorpay.customers.deleteToken(customerId, tokenId);
  ```

  ```php PHP theme={null}
  $api = new Api($key_id, $secret);

  $api->customer->fetch($customerId)->tokens()->delete($tokenId);
  ```

  ```javascript Node.js theme={null}
  var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

  instance.customers.deleteToken(customerId, tokenId)
  ```

  ```python Python theme={null}
  client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

  client.token.delete(customerId, tokenId)
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  customerId = "cust_1Aa00000000004"

  tokenId = "token_Hxe0skTXLeg9pF"

  Razorpay::Customer.fetch(customerId).deleteToken(tokenId)
  ```

  ```go Go theme={null}
  import ( razorpay "github.com/razorpay/razorpay-go" )
  client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

  body, err := client.Token.Delete("<customerId>", "<tokenId>", nil, nil)
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  customerId = "cust_1Aa00000000004"

  tokenId = "token_Hxe0skTXLeg9pF"

  Razorpay::fetch(customerId).deleteToken(tokenId)
  ```

  ```java Java theme={null}
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  String customerId = "cust_DtHaBuooGHTuyZ";

  String tokenId = "token_HouA2OQR5Z2jTL";

  Customer customer = instance.customers.deleteToken(customerId, tokenId);
  ```

  ```csharp .NET theme={null}
  RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  string customerId = "cust_Z6t7VFTb9xHeOs";

  string tokenId = "token_1Aa00000000001";

  Customer customer = client.Customer.Fetch(customerId).DeleteToken(tokenId);
  ```

  ```json Response theme={null}
  {
      "deleted": true
  }
  ```
</CodeGroup>

#### Path Parameter

`customer_id` *mandatory*
: `string` The unique identifier of the customer with whom the token is linked. For example, `cust_1Aa00000000002`.

`token_id` *mandatory*
: `string` The unique identifier of the token that is to be deleted. For example, `token_1Aa00000000001`.

## 3. Create Subsequent Payments

You should perform the following steps to create and charge your customer subsequent payments:

1. [Create an order to charge the customer](#3-1-create-an-order-to-charge-the-customer)
2. [Create a recurring payment](#3-2-create-a-recurring-payment)

### 3.1. Create an Order to Charge the Customer

You have to create a new order every time you want to charge your customers. This order is different from the one created during the authorisation transaction.

The following endpoint creates an order.

`POST /orders`

<CodeGroup>
  ```bash Curl theme={null}
  curl -u [YOUR_KEY_ID]:[YOUR_KEY_SECRET] \
  -X POST https://api.razorpay.com/v1/orders \
  -H "Content-Type: application/json" \
  -d '{
    "amount":1000,
    "currency":"INR",
    "payment_capture": true,
    "receipt":"Receipt No. 1",
    "notes": {
      "notes_key_1":"Tea, Earl Grey, Hot",
      "notes_key_2":"Tea, Earl Grey… decaf."
    }
  }'
  ```

  ```java Java theme={null}
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  JSONObject orderRequest = new JSONObject();
  orderRequest.put("amount", 1000);
  orderRequest.put("currency", "INR");
  orderRequest.put("payment_capture", true);
  orderRequest.put("receipt", "Receipt No. 1");
  JSONObject notes = new JSONObject();
  notes.put("notes_key_1","Tea, Earl Grey, Hot");
  notes.put("notes_key_2","Tea, Earl Grey… decaf.");
  orderRequest.put("notes", notes);

  Order order = razorpay.orders.create(orderRequest);
  ```

  ```php PHP theme={null}
  $api = new Api($key_id, $secret);

  $api->order->create(array('receipt' => '123', 'amount' => 100, 'payment_capture' => true, 'currency' => 'INR', 'notes'=> array('key1'=> 'value3','key2'=> 'value2')));
  ```

  ```javascript Node.js theme={null}
  var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

  instance.orders.create({
    "amount":1000,
    "currency":"INR",
    "payment_capture": true,
    "receipt":"Receipt No. 1",
    "notes": {
      "notes_key_1":"Tea, Earl Grey, Hot",
      "notes_key_2":"Tea, Earl Grey… decaf."
    }
  })
  ```

  ```python Python theme={null}
  client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

  client.order.create({
      'amount': 1000,
      'currency': 'INR',
      'payment_capture': True,
      'receipt': 'Receipt No. 1',
      'notes': {'notes_key_1': 'Tea, Earl Grey, Hot',
                'notes_key_2': 'Tea, Earl Grey... decaf.'}
      })
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  para_attr = {
    "amount": 1000,
    "currency": "INR",
    "payment_capture": true,
    "receipt": "Receipt No. 1",
    "notes": {
      "notes_key_1": "Tea, Earl Grey, Hot",
      "notes_key_2": "Tea, Earl Grey… decaf."
    }
  }

  Razorpay::Order.create(para_attr)
  ```

  ```go Go theme={null}
  import ( razorpay "github.com/razorpay/razorpay-go" )
  client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_S ECRET")

  data:= map[string]interface{}{
    "amount":1000,
    "currency":"INR",
    "payment_capture": true,
    "receipt":"Receipt No. 1",
    "notes": map[string]interface{}{
      "notes_key_1":"Tea, Earl Grey, Hot",
      "notes_key_2":"Tea, Earl Grey… decaf.",
    },
  }
  body, err := client.Order.Create(data, nil)
  ```

  ```csharp .NET theme={null}
  RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  Dictionary<string, object> orderRequest = new Dictionary<string, object>();
  orderRequest.Add("amount", 100);
  orderRequest.Add("currency", "INR");
  orderRequest.Add("receipt", "receipt#12b");
  orderRequest.Add("payment_capture", true);
  Dictionary<string, object> notes = new Dictionary<string, object>();
  notes.Add("notes_key_1", "Tea, Earl Grey, Hot");
  notes.Add("notes_key_2", "Tea, Earl Grey… decaf.");
  orderRequest.Add("notes", notes);

  Order order = client.Order.Create(orderRequest);
  ```
</CodeGroup>

<CodeGroup>
  ```json Success Response theme={null}
  {
     "id":"order_1Aa00000000002",
     "entity":"order",
     "amount":1000,
     "amount_paid":0,
     "amount_due":1000,
     "currency":"INR",
     "receipt":"Receipt No. 1",
     "offer_id":null,
     "status":"created",
     "attempts":0,
     "notes":{
        "notes_key_1":"Tea, Earl Grey, Hot",
        "notes_key_2":"Tea, Earl Grey… decaf."
     },
     "created_at":1579782776
  }
  ```

  ```json Failure Response theme={null}
  {
     "error":{
        "code":"BAD_REQUEST_ERROR",
        "description":"The id provided does not exist",
        "source":"business",
        "step":"payment_initiation",
        "reason":"input_validation_failed",
        "metadata":{
           
        }
     }
  }
  ```
</CodeGroup>

### 3.2. Create a Recurring Payment

Once you have generated an `order_id`, use it with the `token_id` to create a payment and charge the customer. The following endpoint creates a payment to charge the customer.

`POST /payments/create/recurring`

<CodeGroup>
  ```bash Curl theme={null}
  curl -u [YOUR_KEY_ID]:[YOUR_KEY_SECRET] \
  -X POST https://api.razorpay.com/v1/payments/create/recurring \
  -H "Content-Type: application/json" \
  -d '{
    "email": "<email>",
    "contact": "<phone>",
    "amount": 1000,
    "currency": "INR",
    "order_id": "order_1Aa00000000002",
    "customer_id": "cust_1Aa00000000001",
    "token": "token_1Aa00000000001",
    "recurring": true,
    "description": "Creating recurring payment for <name>",
    "notes": {
      "note_key 1": "Beam me up Scotty",
      "note_key 2": "Tea. Earl Gray. Hot."
    }
  }'
  ```

  ```java Java theme={null}
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  JSONObject paymentRequest = new JSONObject();
  paymentRequest.put("email", "<email>");
  paymentRequest.put("contact", "<phone>");
  paymentRequest.put("amount", 1000);
  paymentRequest.put("currency", "INR");
  paymentRequest.put("order_id", "order_1Aa00000000002");
  paymentRequest.put("customer_id", "cust_1Aa00000000001");
  paymentRequest.put("token", "token_1Aa00000000001");
  paymentRequest.put("recurring", true);
  paymentRequest.put("description", "Creating recurring payment for <name>");
  JSONObject notes = new JSONObject();
  paymentRequest.put("notes_key_1","Tea, Earl Grey, Hot");
  paymentRequest.put("notes_key_2","Tea, Earl Grey… decaf.");

  Payment payment = razorpay.payments.createRecurringPayment(paymentRequest);
  ```

  ```php PHP theme={null}
  $api = new Api($key_id, $secret);

  $api->payment->createRecurring(array('email'=>'<email>','contact'=>'<phone>','amount'=>100,'currency'=>'INR','order_id'=>'order_1Aa00000000002','customer_id'=>'cust_1Aa00000000001','token'=>'token_1Aa00000000001','recurring'=>true,'description'=>'Creating recurring payment for <name>'));
  ```

  ```javascript Node.js theme={null}
  var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

  instance.payments.createRecurringPayment({
    "email": "<email>",
    "contact": "<phone>",
    "amount": 1000,
    "currency": "INR",
    "order_id": "order_1Aa00000000002",
    "customer_id": "cust_1Aa00000000001",
    "token": "token_1Aa00000000001",
    "recurring": true,
    "description": "Creating recurring payment for <name>",
    "notes": {
      "note_key 1": "Beam me up Scotty",
      "note_key 2": "Tea. Earl Gray. Hot."
    }
  })
  ```

  ```python Python theme={null}
  client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

  client.payment.createRecurring({
      'email': '<email>',
      'contact': <phone>,
      'amount': 1000,
      'currency': 'INR',
      'order_id': "order_1Aa00000000002",
      'customer_id': "cust_1Aa00000000001",
      'token': 'token_1Aa00000000001',
      'recurring': True,
      'description': 'Creating recurring payment for <name>',
      'notes': {'note_key 1': 'Beam me up Scotty',
                'note_key 2': 'Tea. Earl Gray. Hot.'}
      })
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  para_attr = {
    "email": "<email>",
    "contact": "<phone>",
    "amount": 1000,
    "currency": "INR",
    "order_id": "order_1Aa00000000002",
    "customer_id": "cust_1Aa00000000001",
    "token": "token_1Aa00000000001",
    "recurring": true,
    "description": "Creating recurring payment for <name>",
    "notes": {
      "note_key 1": "Beam me up Scotty",
      "note_key 2": "Tea. Earl Gray. Hot."
    }
  }
  Razorpay::Payment.create_recurring_payment(para_attr)
  ```

  ```go Go theme={null}
  import ( razorpay "github.com/razorpay/razorpay-go" )
  client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

  data:= map[string]interface{}{
    "email": "<email>",
    "contact": "<phone>",
    "amount": 1000,
    "currency": "INR",
    "order_id": "order_1Aa00000000002",
    "customer_id": "cust_1Aa00000000001",
    "token": "token_1Aa00000000001",
    "recurring": true,
    "description": "Creating recurring payment for <name>",
    "notes": map[string]interface{}{
      "note_key 1": "Beam me up Scotty",
      "note_key 2": "Tea. Earl Gray. Hot.",
    },
  }
  body, err := Client.Payment.CreateRecurringPayment(data, nil)
  ```

  ```csharp .NET theme={null}
  RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  Dictionary<string, object> paymentRequest = new Dictionary<string, object>();
  paymentRequest.Add("email", "<email>");
  paymentRequest.Add("contact", "<phone>");
  paymentRequest.Add("amount", 1000);
  paymentRequest.Add("currency", "INR");
  paymentRequest.Add("order_id", "order_MZ35KPxZaqxfXq");
  paymentRequest.Add("customer_id", "cust_KUyah9o60OPhfj");
  paymentRequest.Add("token", "token_MZ37MsnhLNH4tN");
  paymentRequest.Add("recurring", true);
  paymentRequest.Add("description", "Creating recurring payment for <name>");
  Dictionary<string, object> notes = new Dictionary<string, object>();
  notes.Add("notes_key_1", "Tea, Earl Grey, Hot");
  notes.Add("notes_key_2", "Tea, Earl Grey… decaf.");
  paymentRequest.Add("notes", notes);

  Payment payment = client.Payment.CreateRecurringPayment(paymentRequest);
  ```
</CodeGroup>

<CodeGroup>
  ```json Success Response theme={null}
  {
    "razorpay_payment_id" : "pay_1Aa00000000001"
  }
  ```

  ```json Failure Response theme={null}
  {
     "error":{
        "code":"BAD_REQUEST_ERROR",
        "description":"Amount exceeds maximum amount allowed",
        "source":"business",
        "step":"payment_initiation",
        "reason":"input_validation_failed",
        "metadata":{
           
        }
     }
  }
  ```
</CodeGroup>

#### Request Parameters

`email ` *mandatory*
: `string` The customer's email address. For example, `gaurav.kumar@example.com`.

`contact ` *mandatory*
: `integer` The customer's phone number. For example, `9876543210`.

`currency` *mandatory*
: `string` 3-letter ISO currency code for the payment. Currently, only `INR` is allowed.

`amount` *mandatory*
: `integer` The amount you want to charge your customer. This should be the same as the order amount.

`order_id`*mandatory*
: `string` The unique identifier of the order created. For example, `order_1Aa00000000002`.

`customer_id` *mandatory*
: `string` The unique identifier of the customer you want to charge. For example, `cust_1Aa00000000002`.

`token` *mandatory*
: `string` The `token_id` generated when the customer successfully completes the authorisation payment. Different payment instruments for the same customer have different `token_id`.

`recurring` *mandatory*
: `boolean` Determines whether recurring payment is enabled or not.

* `true`: Recurring payment is enabled.
* `false`: Recurring payment is not enabled.

`description`*optional*
: `string` A user-entered description for the payment. For example, `Creating recurring payment for Gaurav Kumar`

`notes`*optional*
: `object` Key-value pair you can use to store additional information about the entity. Maximum of 15 key-value pairs, 256 characters each. For example, `"note_key": "Beam me up Scotty”`.
